require( "internal.lua" )

class( "PriorityQueue" )

function PriorityQueue:__init( ... )
	self.data = { }
end

function PriorityQueue:__tostring( )
	return string.format( "PriorityQueue( size=%d )", #self.data )
end

function PriorityQueue:Enqueue( value, priority )
	local _t = { _p = priority, _v=value }
	local final_pos = 1
	for i, d in ipairs( self.data ) do
		if priority > d._p then
			final_pos = final_pos + 1
		else
			break
		end
	end
	table.insert( self.data, final_pos, _t )
end

function PriorityQueue:Dequeue( )
	if #self.data == 0 then
		return nil
	end
	return table.remove( self.data, 1 )._v
end

function PriorityQueue:DequeueWithKey( )
	if #self.data == 0 then
		return nil
	end
	local _t = table.remove( self.data, 1 )
	return _t._p, _t._v
end

function PriorityQueue:AdjustPriorities( add )
	for i, _t in ipairs( self.data ) do
		_t._p = _t._p + add
	end
end

function PriorityQueue:Size( )
	return #self.data
end

function PriorityQueue:Peek( )
	if #self.data == 0 then
		return nil
	end
	return self.data[1]._v
end

function PriorityQueue:Clear( )
	for i,_ in ipairs( self.data ) do
		 self.data[i] = nil
	end
end
