require( "internal.lua" )

class( "Queue" )

function Queue._parse_args( args )
	local _l = #args
	if _l == 0 then
		return {}
	elseif _l == 1 then
		local _t = __type( args[1] )
		if _t == "table" then
			return args[1]
		elseif _t == "List" or _t == "Stack" then
			return args[1].data
		end
	end
	error( "Cannot Initialize Queue; Check arguments: "..type( args ) )
end

function Queue:__init( ... )
	self.data = Queue._parse_args( table.pack( ... ) )
end

function Queue:__tostring( )
	return string.format( "Queue( size=%d )", #self.data )
end

function Queue:Enqueue( value )
	table.insert( self.data, value )
end

function Queue:Dequeue( )
	return table.remove( self.data, 1 )
end

function Queue:Size( )
	return #self.data
end

function Queue:Peek( )
	return self.data[1]
end

function Queue:Clear( )
	for i,_ in ipairs( self.data ) do
		self.data[i] = nil
	end
end
