require( "ScriptProperties.lua" )

function Script_GetNode( self ) 
	return self.__node
end

function Script_SetPosition( self , ... ) 
	return self.__node:SetPosition( ... ) 
end

function Script_GetPosition( self ) 
	return self.__node:GetPosition( ) 
end

function Script_GetWorldPosition( self ) 
	return self.__node:GetWorldPosition( ) 
end

function Script_SetRotation( self , ... ) 
	return self.__node:SetRotation( ... ) 
end

function Script_GetRotation( self ) 
	return self.__node:GetRotation( ) 
end

function Script_GetWorldRotation( self ) 
	return self.__node:GetWorldRotation( ) 
end

function Script_SetScale( self , ... ) 
	return self.__node:SetScale( ... ) 
end

function Script_GetScale( self ) 
	return self.__node:GetScale( )
end


function Script_SetVisible( self , ... ) 
	return self.__node:SetVisible( ... ) 
end

function Script_GetVisible( self ) 
	return self.__node:GetVisible( )
end

function Script_GetWorldVisible( self ) 
	return self.__node:GetWorldVisible( )
end

function Script_SetActive( self , ... ) 
	return self.__node:SetActive( ... ) 
end

function Script_GetActive( self ) 
	return self.__node:GetActive( )
end

function Script_GetWorldActive( self ) 
	return self.__node:GetWorldActive( )
end

function Script_ImportChild( self , scene ) 
	return self.__node:ImportChild( scene ) 
end

function Script_PrepareChild( self , scene ) 
	return self.__node:PrepareChild( scene ) 
end

function Script_CreateChild( self , id ) 
	return self.__node:CreateChild( id ) 
end

function Script_GetScene( self ) 
	return self.__node:GetScene( ) 
end

function Script_GetParent( self ) 
	return self.__node:GetParent( ) 
end

function Script_AddComponent( self , id ) 
	return self.__node:AddComponent( id ) 
end

function Script_FindComponent( self , id ) 
	return self.__node:FindComponent( id ) 
end

function Script_GetComponents( self , id ) 
	return self.__node:GetComponents( id ) 
end

function Script_AddScript( self , id ) 
	return self.__node:AddScript( id ) 
end

function Script_FindScript( self , id ) 
	return self.__node:FindScript( id ) 
end

function Script_RemoveScript( self , id ) 
	return self.__node:RemoveScript( id ) 
end

function Script_Start( self ) 
	return self.__node:Start( ) 
end

function Script_Start( self ) 
	return self.__node:Start( ) 
end

function Script_Destroy( self , id ) 
	return self.__node:Destroy( id ) 
end

function Script_FindChild( self , child_id ) 
	return self.__node:FindChild( child_id ) 
end

function Script_GetChild( self , child_id ) 
	return self.__node:GetChild( child_id ) 
end

function Script_GetChildren( self ) 
	return self.__node:GetChildren( ) 
end


function Script_init( object , class_table )

	local properties = rawget( class_table , "__properties" )
	if properties then
		for id,property_data in pairs( properties ) do
			object[ id ] = property_data.default_value
		end
	end

end


function Script( typename , base_class_name )
	
	local class_table = class( typename , base_class_name )
	
	class_table.__init = function( object ) Script_init( object , class_table ) end

	class_table.GetNode = Script_GetNode
	class_table.ImportChild = Script_ImportChild
	class_table.PrepareChild = Script_PrepareChild
	class_table.CreateChild = Script_CreateChild
	class_table.Start = Script_Start
	class_table.Destroy = Script_Destroy
	class_table.GetScene = Script_GetScene
	class_table.GetParent = Script_GetParent
	class_table.GetChild = Script_GetChild
	class_table.GetChildren = Script_GetChildren
	class_table.FindChild = Script_FindChild
	class_table.SetPosition = Script_SetPosition
	class_table.GetPosition = Script_GetPosition
	class_table.GetWorldPosition = Script_GetWorldPosition
	class_table.SetRotation = Script_SetRotation
	class_table.GetRotation = Script_GetRotation
	class_table.GetWorldRotation = Script_GetWorldRotation
	class_table.SetScale = Script_SetScale
	class_table.GetScale = Script_GetScale

	class_table.SetVisible = Script_SetVisible
	class_table.GetVisible = Script_GetVisible
	class_table.GetWorldVisible = Script_GetWorldVisible

	class_table.SetActive = Script_SetActive
	class_table.GetActive = Script_GetActive
	class_table.GetWorldActive = Script_GetWorldActive

	class_table.AddScript = Script_AddScript
	class_table.FindScript = Script_FindScript
	class_table.RemoveScript = Script_RemoveScript
	
	class_table.AddComponent = Script_AddComponent
	class_table.FindComponent = Script_FindComponent
	class_table.GetComponents = Script_GetComponents

	return ScriptProperties( class_table )

end