require( "internal.lua" )

class( "ScriptProperties" )

function ScriptProperties:__init( owner )
	self.Owner = owner
end

function ScriptProperties:AddProperty( property_name , type_index , default_value )
	local new_property = { }
	new_property.type = type_index
	new_property.default_value = default_value
	
	local properties_table = rawget( self.Owner , "__properties" )
	if properties_table == nil then
		properties_table = { }
		properties_table[ property_name ] = new_property
		rawset( self.Owner , "__properties" , properties_table )
	else
		properties_table[ property_name ] = new_property
	end

	return self
end

function ScriptProperties:Integer( name , default_value )
	return self:AddProperty( name , 1 , default_value )
end

function ScriptProperties:Float( name , default_value )
	return self:AddProperty( name , 2 , default_value )
end

function ScriptProperties:String( name , default_value )
	return self:AddProperty( name , 3 , default_value )
end

function ScriptProperties:Vector3( name , default_value )
	return self:AddProperty( name , 4 , default_value )
end

function ScriptProperties:Color( name , default_value )
	return self:AddProperty( name , 5 , default_value )
end