require( "internal.lua" )

class( "Stack" )

function Stack._parse_args( args )
	local _l = #args
	if _l == 0 then
		return {}
	elseif _l == 1 then
		local _t = __type( args[1] )
		if _t == "table" then
			return args[1]
		elseif _t == "List" or _t == "Queue" then
			return args[1].data
		end
	end
	error( "Cannot Initialize Stack; Check arguments: "..type( args ) )
end

function Stack:__init( ... )
	self.data = Stack._parse_args( table.pack( ... ) )
end

function Stack:__tostring( )
	return string.format( "Stack( size=%d )", #self.data )
end

function Stack:Push( value )
	table.insert( self.data, value )
end

function Stack:Pop( )
	local _s = self:Size()
	if _s == 0 then
		return nil
	end
	return table.remove( self.data, _l )
end

function Stack:Size( )
	return #self.data
end

function Stack:Peek( )
	return self.data[#self.data]
end

function Stack:Clear( )
	for i,_ in ipairs( self.data ) do
		self.data[i] = nil
	end
end
