
function __concat( p1 , p2 )
	return tostring( p1 ) .. tostring( p2 )
end

function __init( object , class_table , ... )
	if ( class_table.__parent ) then
		__init( object , class_table.__parent , ... )
	end

	local init_method = rawget( class_table , "__init" )
	if ( init_method ) then
		init_method( object , ... )
	end
end

function __type( object )
	local t = type( object )
	if t == "table" and object.__type then
		return object.__type
	else
		return t
	end
end

function class( typename , base_class )

	local class_table = { }
	class_table.__index = class_table
	class_table.__concat = __concat
	class_table.__type = typename
	class_table.__tostring = function( ) return typename end

	local class_meta_table = { }
	setmetatable( class_table , class_meta_table )

	base_class = base_class and _G[ base_class ]
	if base_class then
		class_table.__parent = base_class
		class_meta_table.__index = base_class
	end

	class_meta_table.__call = function( self , ... )
		local object = { }
		setmetatable( object , class_table )
		__init( object , class_table , ... )
		return object
	end

	_G[ typename ] = class_table
	
	return class_table

end

